using UnityEngine;
using PixelCrushers;
using PixelCrushers.DialogueSystem;
using System.Collections;
using DG.Tweening;

// TODO: NOT USED

public class CustomUISubtitlePanel : StandardUISubtitlePanel {
	// Loosely based on QueueSubtitleDialogueUI from https://www.pixelcrushers.com/phpbb/viewtopic.php?f=3&t=2251#p12369

	//public float hideSubtitleDelay = 1;

	//private StandardUISubtitlePanel currentVisiblePanel = null;
	//private bool showContinueButton = false;

	// Private vars
	private CanvasGroup canvasGroup;

	// Settings
	[Header("Custom settings ")]
	[SerializeField]
	private float durationShow = 0.3f;

	[SerializeField]
	private float durationHide = 0.3f;

	[SerializeField]
	private Ease curveShow;

	[SerializeField]
	private Ease curveHide;

	protected override void Start() {
		base.Start();
		canvasGroup = GetComponent<CanvasGroup>();
	}

	public override void ShowSubtitle(Subtitle subtitle) {
		// StandardUISubtitlePanel
		SetUIElementsActive(true);
		if (!isOpen) hasFocus = false;
		CustomOpen();
		Focus();
		SetContent(subtitle);
		//CheckSubtitleAnimator(subtitle);
	}

	/// <summary>
	/// Hides a subtitle, playing the unfocus and close animations.
	/// </summary>
	public override void HideSubtitle(Subtitle subtitle) {
		if (panelState != PanelState.Closed) Unfocus();
		CustomClose();
	}

	public virtual void CustomOpen() {
		Debug.Log("<color=magenta>CustomOpen</color> " + panel.localScale + " " + canvasGroup.alpha);

		if (panelState == PanelState.Open || panelState == PanelState.Opening) return;
		panelState = PanelState.Opening;
		gameObject.SetActive(true);
		onOpen.Invoke();

		//animatorMonitor.SetTrigger(showAnimationTrigger, OnVisible, waitForShowAnimation);
		panel.DOScale(new Vector3(1, 1, 1), durationShow).SetEase(curveShow);
		DOTween.To(() => canvasGroup.alpha, x => canvasGroup.alpha = x, 1.0f, durationShow).SetEase(curveShow);

		// With quick panel changes, panel may not reach OnEnable/OnDisable before being reused.
		// Update panelStack here also to handle this case:
		PushToPanelStack();
	}

	protected virtual void CustomClose() {
		Debug.Log("<color=magenta>CustomClose</color> " + panel.localScale + " " + canvasGroup.alpha); // StandardUISubtitlePanel

		if (isOpen) base.Close();

		// UIPanel
		PopFromPanelStack();
		CancelInvoke();
		if (panelState == PanelState.Closed || panelState == PanelState.Closing) return;
		panelState = PanelState.Closing;
		onClose.Invoke();

		//animatorMonitor.SetTrigger(hideAnimationTrigger, OnHidden, true);
		panel.DOScale(new Vector3(0, 0, 0), durationHide).SetEase(curveHide);
		DOTween.To(() => canvasGroup.alpha, x => canvasGroup.alpha = x, 0f, durationHide).SetEase(curveHide);

		// Deselect ours:
		if (UnityEngine.EventSystems.EventSystem.current != null && selectables.Contains(UnityEngine.EventSystems.EventSystem.current.currentSelectedGameObject)) {
			UnityEngine.EventSystems.EventSystem.current.SetSelectedGameObject(null);
		}

		// StandardUISubtitlePanel
		m_accumulatedText = string.Empty;
		hasFocus = false;
	}

	/*
	public override void HideSubtitle(Subtitle subtitle) {

		if (subtitle == null) return;
		DialogueActor dialogueActor;
		var panel = GetPanel(subtitle, out dialogueActor);
		if (SubtitleUsesBarkUI(subtitle)) return;
		if (panel == null)
		{
			if (DialogueDebug.logWarnings) Debug.LogWarning("Dialogue System: Can't find subtitle panel for " + GetSubtitleTextSummary(subtitle) + ".");
		}
		else if (panel.visibility == UIVisibility.OnlyDuringContent)
		{
			panel.HideSubtitle(subtitle);
		}
		else
		{
			panel.FinishSubtitle();
		}
		
		// Ignore the START-node
		//if (subtitle.dialogueEntry.DialogueText.Length == 0) return;

		//Debug.Log(Time.time.ToString("F1") + ": Hide subtitle on " + (Time.time + hideSubtitleDelay).ToString("F1") + " " + subtitle.speakerInfo.Name);

		//StartCoroutine(DelayHideSubtitle(subtitle));
		
	}
	*/

	/*
	IEnumerator DelayHideSubtitle(Subtitle subtitle) {
		Debug.Log(Time.time.ToString("F1") + ": <color=white>Start subtitle hide animation</color> ");

		// Play subtitle close animation
		animatorMonitor.SetTrigger(hideAnimationTrigger, OnHidden, true);

		var timeout = Time.time + hideSubtitleDelay;

		while (Time.time < timeout) {
			Debug.Log(timeout - Time.time);
			yield return null;
		}

		Debug.Log(Time.time.ToString("F1") + ": Hiding subtitle for real ");
		base.HideSubtitle(subtitle);
	}

	public override void Close() {
		currentVisiblePanel = null;
		base.Close();
	}
	*/
}